' Sparrow-Zahlenausgabe via Led (und Piezo) dezimal bis 65535 (=word)
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 16                                  '32
$swstack = 4                                   '8
$framesize = 8                                 '16
$programmer = 19                               'UsbAsp

Green Alias Portb.1 : Red Alias Portb.3
U0 Alias Getadc(0)                             'reset
U1 Alias Getadc(1)                             'B.2, S2
U2 Alias Getadc(2)                             'B.4, aux
U3 Alias Getadc(3)                             'B.3, Led rot

Ddrb = &B00010 : Portb = &B00101               'aux, red, S2, green, S1 : pullup

Config Adc = Single , Prescaler = Auto , Reference = Avcc : Start Adc
Config Timer0 = Pwm , Compare_b_pwm = Clear_up , Prescale = 1 :       '1,2MHz/511/1 = ~2344Hz = ~425,83us
Start Timer0

Const Wartkurz = 25
Const Wartlang = 200

Declare Sub Zeig_dez                           'bis 65535
Declare Sub Zeig                               'eine Ziffer
Declare Sub Gblitz                             'grn blitzt

Declare Sub Mittelwert                         'test adc(2)

Dim I As Byte , J As Byte
Dim Tmpb(5) As Byte
Dim Tmpw(5) As Word

Dim Ab_stelle As Byte
Dim Bis_stelle As Byte

Do
   Mittelwert
'   Tmpw(3) = 65432                             'test word
'   Tmpw(3) = 43210                             'test word

   Ab_stelle = 2                               'ad-wert 4-stellig
   Bis_stelle = 5

   Zeig_dez
   Wait 5
Loop
'-------------------------------------------------------------------------------
Sub Zeig_dez:
   Tmpw(1) = Tmpw(3)
   For J = 5 To 1 Step -1                      'ziffern isolieren, von hinten
      Tmpw(2) = Tmpw(1) Mod 10
      Tmpb(j) = Tmpw(2)
      Tmpw(1) = Tmpw(1) / 10
   Next J
   For J = Ab_stelle To Bis_stelle :           'von vorn nach hinten
      Zeig :
   Next J
End Sub

Sub Zeig:
   Gblitz                                      'begin mit blitz
   For I = 1 To Tmpb(j) :                      'eine ziffer
      Waitms Wartlang :
      Pwm0b = 128:                             'Green = 1 :
      Waitms Wartlang :
      Pwm0b = 0:                               'Green = 0 :
   Next I
   Wait 1                                      'Zifferende
End Sub

Sub Gblitz :                                   'grn blitzt
   For I = 0 To 4 :
      Waitms Wartkurz :
      Pwm0b = 128:
      Waitms Wartkurz :
      Pwm0b = 0:
   Next I :
   Waitms Wartlang :
End Sub
'-------------------------------------------------------------------------------
Sub Mittelwert :
'Aus 64 Adc-Werten der roten Led wird der Mittelwert gebildet.
   Tmpw(3) = 0                                 'Integral ber 64 Werte
   For I = 0 To 63 :
      Tmpw(3) = Tmpw(3) + U3 :                 '~1V..1,4V -> Ad3= 200..500
      Waitms 1 :                               'Messdauer*64
   Next :
   Tmpw(3) = Tmpw(3) / 64                      'Tiefpass
End Sub
'-------------------------------------------------------------------------------